<?php

require '../bootstrap/bootstrap.php';
$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();

$mongoOptions['typeMap'] = [
    'array'    => 'array',
    'document' => 'array',
    'root'     => 'array',
];
$db = (new \MongoDB\Client("mongodb://mongoteste.teknisa.com:27020", array(), $mongoOptions))->TeknisaLicense;

foreach ($db->listCollections() as $collectionInfo) {
    if(strpos($collectionInfo['name'], 'VariableMeasure_') !== false) {
        $collection = $db->selectCollection($collectionInfo['name']);
        $rows       = $collection->find()->toArray();
        foreach($rows as $row) {
            if(!is_int($row['date'])) {
                $row['date']           = intval($row['date']->toDateTime()->format('Ymd'));
                $row['endCompetence']  = intval($row['endCompetence']->toDateTime()->format('Ymd'));
                $row['initCompetence'] = intval($row['initCompetence']->toDateTime()->format('Ymd'));
                
                $row['id']            = strval($row['id']);
                $row['productId']     = strval($row['productId']);
                $row['measureCode']   = strval($row['measureCode']);
                $row['contractId']    = strval($row['contractId']);
                $row['contractExpId'] = strval($row['contractExpId']);
                if(isset($row['count'])) {
                    $row['count']         = strval($row['count']);
                }
                if(isset($row['serviceId'])) {
                    $row['serviceId']     = empty($row['serviceId']) ? $row['serviceId'] : strval($row['serviceId']);
                }
                
                $updateResult = $collection->replaceOne(array('_id' => $row['_id']), $row);
            }
        }
        $collectionName = $collectionInfo['name'];
        echo "End Collection $collectionName \n";
    }
}