<?php
namespace OrganizationsManagement\Factory;
use Teknisa\Model\Teknisa\Entities\OmProdutoElemento as ElementoEntity;
use Teknisa\Model\Teknisa\Entities\OmProdutoOrgElemento as ElementoOrgEntity;
use Teknisa\Model\Teknisa\Entities\OmProdutoElementoOrgEspec as ElementoOrgEspecEntity;
use OrganizationsManagement\Util\Utilities as Utilities;
use Teknisa\Model\Util\NovoCodigo as NovoCodigo;

class Elemento {

    public function save(ElementoEntity $element=null, $UniqueId, $parentId, $produtoId, $orgId, $label, $codOperador, $dateNow, $externalProductId, $nrOrdem, $idelementopadrao)
    {
        if ($element === null){
            $element = new ElementoEntity();
            $novoCodigo = NovoCodigo::geraCodigo($orgId, "OmProdutoElemento", 1, 10, false, false);
            $element->setId($novoCodigo ? $novoCodigo : 1);
            $element->setDtinclusao($dateNow);
            $element->setNrorginclusao($orgId);
            $element->setCdoperinclusao($codOperador);
            $element->setUniqueId($UniqueId);
            $element->setNrprodutoId($produtoId);
        }
        
        $element->setParentId($parentId);
        $element->setNrorg($orgId);
        $element->setLabel($label);
        $element->setDtultatu($dateNow); 
        $element->setNrorgultatu($orgId);
        $element->setCdoperultatu($codOperador);
        $element->setNrexternalProductId($externalProductId);
        $element->setNrOrdem($nrOrdem);
        $element->setIdelementopadrao($idelementopadrao);

        return $element;
    }

    public function saveElementProductOrg($elementProductOrg, $elementId, $currentOrgId, $dateNow, $codOperador, $idAtivo = 'S')
    {
        $element = new ElementoOrgEntity();
        $novoCodigo = NovoCodigo::geraCodigo($currentOrgId, "OmProdutoOrgElemento", 1, 10, false, false);
        $element->setId($novoCodigo ? $novoCodigo : 1);
        $element->setCdoperinclusao($codOperador);
        $element->setCdoperultatu($codOperador);
        $element->setDtinclusao($dateNow);
        $element->setDtultatu($dateNow);
        $element->setIdativo($idAtivo);
        $element->setNrorg($currentOrgId);
        $element->setNrorginclusao($currentOrgId);
        $element->setNrorgultatu($currentOrgId);
        $element->setNrprodutoElementoId($elementId);
        $element->setNrprodutoOrgId($elementProductOrg);

        return $element;
    }

    public function saveElementOrgEspec($elementId, $orgId, $currentOrgId, $dateNow, $codOperador, $idAtivo = 'S')
    {
        $element = new ElementoOrgEspecEntity();
        $novoCodigo = NovoCodigo::geraCodigo($currentOrgId, "OM_PRODUTO_ELEMENTO_ORG_ESPEC", 1, 10, false, false);
        $element->setId($novoCodigo);
        $element->setCdoperinclusao($codOperador);
        $element->setCdoperultatu($codOperador);
        $element->setDtinclusao($dateNow);
        $element->setDtultatu($dateNow);
        $element->setIdativo($idAtivo);
        $element->setNrorg($currentOrgId);
        $element->setNrorginclusao($currentOrgId);
        $element->setNrorgultatu($currentOrgId);
        $element->setNrprodutoElementoId($elementId);
        $element->setNrorgId($orgId);

        return $element;
    }

}
